


-- (dotNetClass "system.io.directory").GetFiles "C:\files" "*.max" (dotNetClass "system.io.SearchOption").AllDirectories


/*
/	Script: save viewport screenshot for multiple *.max scenes
/	Author: Panteleev Sergey
/	Year: 2016
/	Contacts: fatbbc @ gmail.com/
*/

try (destroydialog X ) catch ()
 rollout X "batch max scene files to jpg" width:250 (
	
	button setFolder "select folder" width:240
	checkbox subfolders "search in subfolders" checked:true across:2 offset:[-5,5]
	button search "find *.max files" enabled:false width:110 offset:[8,0]
	 
	 
	group "Process" (
		
		label ff "3dsmax scene files: 0" across:2
		button processMaxFiles "Process files" width:100 offset:[0,-5] enabled:false
		progressBar pb "Processed:" value:0 height:8 color:yellow
		
	)
	
	
	local rootFolder
	local maxFiles
	 
	on setFolder pressed do (
		
		rootFolder = getSavePath()		
		search.enabled = ( if rootFolder == undefined then false else true )
		
		if search.enabled then (
			
			
			if rootFolder.count > 40 then (
				
				setFolder.text = "..." + (substring rootFolder (rootFolder.count - 37) rootFolder.count)
				
			) else (
				
				setFolder.text = rootFolder
				
			)
			
			
			
		) else (
			
			setFolder.text = "select folder"
			
		)
		
	)
	
	on search pressed do (
		
		if subfolders.checked then (
		
			maxFiles = (dotNetClass "system.io.directory").GetFiles rootFolder "*.max" (dotNetClass "system.io.SearchOption").AllDirectories
			
		) else (
			
			maxFiles = (dotNetClass "system.io.directory").GetFiles rootFolder "*.max"
			
		)
		
		if maxFiles.count > 0 then (
			
			ff.text = "3dsmax scene files: " + (maxFiles.count as string)
			processMaxFiles.enabled = true
			
		)
	)
	
	on processMaxFiles pressed do (
		
		done = 0
		try ( setVRaySilentMode() ) catch()
		
		for f in maxFiles do (
			
			loadMaxFile f quiet:true			
			ForceCompleteRedraw()
			
			b   = gw.getViewportDib()
			b.filename = maxFilePath + (substring maxFileName 1 (maxFileName.count-4)) + ".jpg"	
			save b
			close b
			done = done + 1
				
			pb.value = 100 * ( done as float / maxFiles.count )
			
		)
		
		messageBox "Completed!"
		
		/*
		
		m=maxFileName; if m!="" do
(    b=gw.getViewportDib(); bn=substring m 1 (m.count-4)
    bfn=maxFilePath+bn+".jpg"; b.filename=bfn; save b; close b ))
		*/
		
	)

	 
	 
)
 createDialog X pos:[100,100]